/* TSP - Branch & Bound */

#include<stdio.h>
void readcost(int n,int a[10][10])
{
   int i,j;
   for(i=1;i<=n;i++)
     for(j=1;j<=n;j++)
       scanf("%d",&a[i][j]);
}

int minrow(int n,int a[10][10],int i)
{
   int min,k;
   min = 999;
    for(k=1;k<=n;k++)
      if(a[i][k] < min)
	min = a[i][k];
      if(min == 999) return 0;
      return min;
}
int mincol(int n,int a[10][10],int j)
{
   int min,k;
   min = 999;
    for(k=1;k<=n;k++)
      if(a[k][j] < min)
	min = a[k][j];
      if(min == 999) return 0;
      return min;
}

int reduce(int n, int a[10][10])
{
   int i,j,min,rcost,ccost;
   rcost = 0;
    for(i=1;i<=n;i++)
      {
       min = minrow(n,a,i);
	for(j=1;j<=n;j++)
	 if(a[i][j] != 999)
	   a[i][j] = a[i][j] - min;
	 rcost = rcost + min;
      }
      ccost = 0;
      for(j=1;j<=n;j++)
      {
       min = mincol(n,a,j);
	for(i=1;i<=n;i++)
	 if(a[i][j] != 999)
	   a[i][j] = a[i][j] - min;
	 ccost = ccost + min;
      }
      return (rcost + ccost);
   }

   int minpos(int n, int a[])
    {
       int min,pos,i;
       min = 999;
       pos = -1;
	for(i=1;i<=n;i++)
	  if(a[i] < min)
	   {
	     min = a[i];
	     pos = i;
	   }
	    return pos;
   }

   void copy(int n,int a[10][10], int p[10][10])
   {
      int i,j;
       for(i=1;i<=n;i++)
	 for(j=1;j<=n;j++)
	   p[i][j] = a[i][j];
   }

   void initialize(int n, int a[10][10], int i,int j)
    {
       int k;
       for(k=1;k<=n;k++)
	 a[i][k] = 999;
       for(k=1;k<=n;k++)
	 a[k][j] = 999;
       a[i][j] = a[j][i] = 999;
    }

   void normalize(int p[],int np,int k,int n,int a[10][10])
   {
      int i,j,ntp,tp[10];
      for(i=1;i<=np;i++) tp[i] = p[i];
      ntp = np + 1;
      tp[ntp] = k;
	for(i=1;i<ntp;i++)
	  for(j=i+1; j<=ntp;j++)
	     initialize(n,a,tp[i],tp[j]);
  }

  int tsp(int n,int a[10][10], int source,int p[])
  {
    int i,j,k,s[10],np,r[10][10],x[10][10],v;
    int rc[10],rp[10],sum,tcost,currentcost,nextcity,pos;
    for(i=1;i<=n;i++) s[i] = 0;
    s[source] = 1;
    p[1]=source;
    np=1;
    copy(n,a,r);
    currentcost = reduce(n,r);
      for(v=1;v<n;v++)
	{
	  j = 1;
	   for(k=1;k<=n;k++)
	     if(s[k] == 0)
	      {
		copy(n,r,x);
		normalize(p,np,k,n,x);
		tcost = reduce(n,x);
		sum = currentcost + tcost + r[p[np]][k];
		rc[j] = sum;
		rp[j] = k;
		j++;
	      }
	    pos = minpos(j-1,rc);
	    nextcity = rp[pos];
	    s[nextcity] = 1;
	    np++;
	    p[np] = nextcity;
	    currentcost = rc[pos];

	 }
       return currentcost;
   }

  void main()
  {
     int n,a[10][10],p[10],source,i,distance;
     clrscr();
     printf("Enter the number of nodes in the graph\n");
     scanf("%d",&n);
     printf("Enter the cost adjacency matrix\n");
     printf("Enter 999 for NoEdge\n");
     readcost(n,a);
     printf("Enter the source\n");
     scanf("%d",&source);
     distance = tsp(n,a,source,p);
     printf("The path traversed is...\n");
      for(i=1;i<=n;i++)
       printf("%d -> ",p[i]);
       printf("%d\n",source);
       printf("\nThe Distance traversed is = %d\n",distance);
       getch();
    }